﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Xml.Serialization;
using System.Drawing;

namespace Azyobuzi.りすにんぐついったー
{
    //個人的にXMLが好きなので
    //http://www.k4.dion.ne.jp/~anis7742/codevault/00080.html のパクリw
    public sealed class SettingsXml
    {
        private SettingsXml() { }

        #region 設定項目
            public uint interval;
            public string template;
            public string accessToken;
            public string accessTokenSecret;
            public Size size;
            public bool auto; 
        #endregion

        private static SettingsXml instance;
        public static SettingsXml Instance
        {
            get
            {
                if (instance == null)
                {
                    try
                    {
                        using (StreamReader sr = new StreamReader(".\\settings.xml")) {
                            XmlSerializer xs = new XmlSerializer(typeof(SettingsXml));
                            instance = (SettingsXml)xs.Deserialize(sr);
                            sr.Close();
                        }
                    }
                    catch
                    {
                        instance = new SettingsXml();
                        //初期化
                        instance.interval = 60u;
                        instance.template = "listening: %0 / %1 #TwitMusic";
                        instance.size = new Size(364, 156);
                        instance.auto = true;
                    }
                }

                return instance;
            }
        }

        public static void Save()
        {
            using (StreamWriter sw = new StreamWriter(".\\settings.xml"))
            {
                XmlSerializer xs = new XmlSerializer(typeof(SettingsXml));
                xs.Serialize(sw, Instance);
                sw.Close();
            }
        }
    }
}
